#include <SFML/Graphics.hpp>
#include <windows.h>
#include <shellapi.h>
#include <fstream>
#include <iostream>
#include <sstream>

#include "Textbox.h"
#include "Button.h"
#include "Filesystem.h"

//для браузера - webkit

int main() {
	//folders and files procesing
	std::string strProjectDirectory = getProjectDir();
	strProjectDirectory.erase((strProjectDirectory.length() - 8), 8);

	std::string strProjectFolder = "AstrumMine\\";

	std::cout << "Project directory is: " + strProjectDirectory + "\n";

	createDir((strProjectDirectory + strProjectFolder).c_str());
	createDir((strProjectDirectory + strProjectFolder + "Profiles").c_str());
	createDir((strProjectDirectory + strProjectFolder + "LauncherData").c_str());

	createFile(" ", strProjectDirectory + strProjectFolder + "LauncherData\\runMinecraft.bat");
	createFile("AllocatedRam=3072\nPathToGameFolder=" + strProjectDirectory, strProjectDirectory + strProjectFolder + "LauncherData\\settings.txt");

	//settings processing
	std::string strSettingsContents;
	writeFileContentsTo(strSettingsContents, strProjectDirectory + strProjectFolder + "LauncherData\\settings.txt");

	int nMaximumRam = 3072;
	int nAllocatedRam = 0;
	std::string strAllocatedRamField = *&strSettingsContents;
	std::string strPathToGameField = *&strSettingsContents;

	strAllocatedRamField.erase((int)strAllocatedRamField.find("PathToGameFolder="), strAllocatedRamField.size());
	strAllocatedRamField.erase((int)strAllocatedRamField.find("AllocatedRam="), (int)strAllocatedRamField.find("AllocatedRam=") + 13);

	strPathToGameField.erase(0, (int)strPathToGameField.find("PathToGameFolder=") + 17);

	std::stringstream sstMain;
	sstMain << strAllocatedRamField;
	sstMain >> nAllocatedRam;

	std::cout << "Settings:\nAllocated ram: " << nAllocatedRam << "\nPath to game: " + strPathToGameField;

	//button controllers
	bool bPlay = false, bSettings1 = false, bSettings2 = false, bSettingsApply = false, bSettingsCancel = false, bDiscord = false, bForgotPassword = false, bAllocatedMemory = false, bPathToGame = false, bNick = false, bPassword = false, bModpack1 = false, bModpack2 = false;

	//SFTP

	//misc
	MEMORYSTATUSEX ram;
	ram.dwLength = sizeof(ram);
	GlobalMemoryStatusEx(&ram);
	std::cout << "Total physically installed ram: " << (unsigned long)ram.ullTotalPhys / 1048576 << " Available: " << (unsigned long)ram.ullTotalPhys / 1048576 - 200 <<"\n";

	nMaximumRam = (int)((unsigned long)ram.ullTotalPhys / 1048576) - 200;

	if (nAllocatedRam > nMaximumRam) {
		nAllocatedRam = nMaximumRam;
	}

	bool bContinueApp = true;

	sf::Font fontMain;
	fontMain.loadFromFile("TaylorSans.ttf");

	std::string strNick;
	std::string strPassword;

	//text
	sf::Text txtSettings(sf::String(L"Настройки"), fontMain, 27);
	txtSettings.setFillColor(sf::Color(180, 180, 180, 255));
	txtSettings.setPosition(325.f, 95.f);

	sf::Text txtSettingsAllocatedRam(sf::String(L"Выделенная память (МБ):"), fontMain, 12);
	txtSettingsAllocatedRam.setFillColor(sf::Color::Black);
	txtSettingsAllocatedRam.setPosition(120.f, 188.f);

	sf::Text txtSettingsPathToGame(sf::String(L"Путь к папке проекта:"), fontMain, 12);
	txtSettingsPathToGame.setFillColor(sf::Color::Black);
	txtSettingsPathToGame.setPosition(139.f, 258.f);

	sf::Text txtCredits(sf::String(L"© Copyright AstrumMine, 2021"), fontMain, 10);
	txtCredits.setFillColor(sf::Color(0, 0, 0, 30));
	txtCredits.setPosition(5.f, 586.f);

	//textures
	sf::Texture txrButtonPlay;
	txrButtonPlay.loadFromFile("buttonwidedef.png");

	sf::Texture txrButtonApply;
	txrButtonApply.loadFromFile("buttondef.png");

	sf::Texture txrButtonCancel;
	txrButtonCancel.loadFromFile("buttoncanceldef.png");

	sf::Texture txrButtonSettings;
	txrButtonSettings.loadFromFile("buttondef.png");

	sf::Texture txrButtonDiscord;
	txrButtonDiscord.loadFromFile("buttondef.png");

	sf::Texture txrGear;
	txrGear.loadFromFile("gear.png");

	sf::Texture txrPlay;
	txrPlay.loadFromFile("play.png");
	
	sf::Texture txrDiscord;
	txrDiscord.loadFromFile("discord.png");

	sf::Texture txrSettingsBG;
	txrSettingsBG.loadFromFile("settingsbg.png");

	sf::Texture txrTextbox;
	txrTextbox.loadFromFile("textbox.png");

	sf::Texture txrLogoBig;
	txrLogoBig.loadFromFile("logobg.png");

	//sprites
	sf::Sprite sprButtonPlay;
	sprButtonPlay.setTexture(txrButtonPlay);

	sf::Sprite sprButtonApply;
	sprButtonApply.setTexture(txrButtonApply);

	sf::Sprite sprButtonCancel;
	sprButtonCancel.setTexture(txrButtonCancel);

	sf::Sprite sprButtonSettings;
	sprButtonSettings.setTexture(txrButtonSettings);

	sf::Sprite sprButtonDiscord;
	sprButtonDiscord.setTexture(txrButtonDiscord);

	sf::Sprite sprGear;
	sprGear.setTexture(txrGear);
	sprGear.setPosition(20.f, 555.f);

	sf::Sprite sprPlay;
	sprPlay.setTexture(txrPlay);
	sprPlay.setPosition(20.f, 515.f);

	sf::Sprite sprDiscord;
	sprDiscord.setTexture(txrDiscord);
	sprDiscord.setPosition(152.f, 555.f);

	sf::Sprite sprSettingsBG;
	sprSettingsBG.setTexture(txrSettingsBG);
	sprSettingsBG.setPosition(100.f, 75.f);

	sf::Sprite sprTextboxAllocatedRam;
	sprTextboxAllocatedRam.setTexture(txrTextbox);

	sf::Sprite sprTextboxPathToGame;
	sprTextboxPathToGame.setTexture(txrTextbox);

	sf::Sprite sprTextboxNick;
	sprTextboxNick.setTexture(txrTextbox);

	sf::Sprite sprTextboxPassword;
	sprTextboxPassword.setTexture(txrTextbox);

	sf::Sprite sprNULL;

	sf::Sprite sprLogoBig;
	sprLogoBig.setTexture(txrLogoBig);
	sprLogoBig.setPosition(263.f, 123.f);

	//buttons
	Button btnPlay(sf::String(L"Играть"), sf::Vector2f(250.f, 30.f), sprButtonPlay, sf::Color::Black);
	btnPlay.setPosition(sf::Vector2f(20.f, 515.f), sf::Vector2f(20.f + 29.f, 515.f));

	Button btnDiscord(sf::String(L"Discord"), sf::Vector2f(120.f, 30.f), sprButtonDiscord, sf::Color::Black);
	btnDiscord.setPosition(sf::Vector2f(150.f, 555.f), sf::Vector2f(150.f + 38.f, 555.f));

	Button btnSettings(sf::String(L"Настройки"), sf::Vector2f(120.f, 30.f), sprButtonSettings, sf::Color::Black);
	btnSettings.setPosition(sf::Vector2f(20.f, 555.f), sf::Vector2f(20.f + 30.f, 555.f));

	Button btnSettingsApply(sf::String(L"Применить"), sf::Vector2f(120.f, 30.f), sprButtonApply, sf::Color::Black);
	btnSettingsApply.setPosition(sf::Vector2f(550.f, 470.f), sf::Vector2f(550.f + 18.f, 470.f));

	Button btnSettingsCancel(sf::String(L"Отмена"), sf::Vector2f(120.f, 30.f), sprButtonCancel, sf::Color::Black);
	btnSettingsCancel.setPosition(sf::Vector2f(130.f, 470.f), sf::Vector2f(130.f + 26.f, 470.f));


	Button btnAllocatedMemory(sf::String(L"Ghost"), sf::Vector2f(240.f, 30.f), sprNULL, sf::Color::Transparent);
	btnAllocatedMemory.setPosition(sf::Vector2f(280.f, 180.f), sf::Vector2f(0.f, 0.f));

	Button btnPathToGame(sf::String(L"Ghost"), sf::Vector2f(240.f, 30.f), sprNULL, sf::Color::Transparent);
	btnPathToGame.setPosition(sf::Vector2f(280.f, 253.f), sf::Vector2f(0.f, 0.f));

	Button btnNick(sf::String(L"Ghost"), sf::Vector2f(240.f, 30.f), sprNULL, sf::Color::Transparent);
	btnNick.setPosition(sf::Vector2f(285.f, 515.f), sf::Vector2f(0.f, 0.f));

	Button btnPassword(sf::String(L"Ghost"), sf::Vector2f(240.f, 30.f), sprNULL, sf::Color::Transparent);
	btnPassword.setPosition(sf::Vector2f(540.f, 515.f), sf::Vector2f(0.f, 0.f));

	//textboxes
	Textbox txbAllocatedRam(15, sf::Color::Black, false, sprTextboxAllocatedRam);
	txbAllocatedRam.setFont(fontMain);
	txbAllocatedRam.setPosition(280.f, 180.f);
	txbAllocatedRam.setLimitSize(5);
	txbAllocatedRam.setLimit(true);
	txbAllocatedRam.setText(std::to_string(nAllocatedRam));

	Textbox txbPathToGame(15, sf::Color::Black, false, sprTextboxPathToGame);
	txbPathToGame.setFont(fontMain);
	txbPathToGame.setPosition(280.f, 253.f);

	Textbox txbNick(15, sf::Color::Black, false, sprTextboxNick);
	txbNick.setFont(fontMain);
	txbNick.setPosition(285.f, 515.f);
	txbNick.setLimitSize(25);

	Textbox txbPassword(15, sf::Color::Black, false, sprTextboxPassword);
	txbPassword.setFont(fontMain);
	txbPassword.setPosition(540.f, 515.f);
	txbPassword.setLimitSize(25);

	//shapes
	sf::RectangleShape shapeBG(sf::Vector2f(800.f, 600.f));
	shapeBG.setFillColor(sf::Color::White);

	sf::RectangleShape shapeLowerBG(sf::Vector2f(800.f, 100.f));
	shapeLowerBG.setFillColor(sf::Color(230, 230, 230, 255));
	shapeLowerBG.setPosition(0.f, 500.f);

	sf::RectangleShape shapeSettingsDarkOverlay(sf::Vector2f(800.f, 600.f));
	shapeSettingsDarkOverlay.setFillColor(sf::Color(0, 0, 0, 150));



	//action loop
	while (windowMain.isOpen()) {

		sf::Event event;

		while (bContinueApp) {

			while (windowMain.pollEvent(event)) {

				if (event.type == sf::Event::Closed) {
					windowMain.close();
				}

				if (!bSettings2) {
					switch (event.type) {
					case sf::Event::MouseButtonPressed:
						if (btnPlay.isMouseOver(windowMain)) {
							txrButtonPlay.loadFromFile("buttonwidepressed.png");
							bPlay = true;
						}

						if (btnSettings.isMouseOver(windowMain)) {
							txrButtonSettings.loadFromFile("buttonpressed.png");
							bSettings1 = true;
						}

						if (btnDiscord.isMouseOver(windowMain)) {
							txrButtonDiscord.loadFromFile("buttonpressed.png");
							bDiscord = true;
						}

						if (btnNick.isMouseOver(windowMain)) {
							bNick = true;
						}
						if (!btnNick.isMouseOver(windowMain)) {
							txbNick.setSelected(false);
						}

						if (btnPassword.isMouseOver(windowMain)) {
							bPassword = true;
						}
						if (!btnPassword.isMouseOver(windowMain)) {
							txbPassword.setSelected(false);
						}
						break;
					case sf::Event::MouseButtonReleased:
						if (bPlay) {
							txrButtonPlay.loadFromFile("buttonwidedef.png");
							bPlay = false;
							system((strProjectDirectory + strProjectFolder + "LauncherData\\runMinecraft.bat").c_str());
						}

						if (bSettings1) {
							txrButtonSettings.loadFromFile("buttondef.png");
							bSettings1 = false;
							bSettings2 = true;
						}

						if (bDiscord) {
							txrButtonDiscord.loadFromFile("buttondef.png");
							bDiscord = false;
							ShellExecute(NULL, (LPCSTR)"open", (LPCSTR)"There was a discord link here, which I deleted", NULL, NULL, SW_SHOW);
						}

						if (bNick) {
							bNick = false;
							txbNick.setSelected(true);
						}

						if (bPassword) {
							bPassword = false;
							txbPassword.setSelected(true);
						}
						break;
					case sf::Event::TextEntered:
						txbNick.onType(event);
						txbPassword.onType(event);
					}
				}

				if (bSettings2) {
					switch (event.type) {
					case sf::Event::MouseButtonPressed:
						if (btnSettingsApply.isMouseOver(windowMain)) {
							txrButtonApply.loadFromFile("buttonpressed.png");
							bSettingsApply = true;
						}

						if (btnSettingsCancel.isMouseOver(windowMain)) {
							txrButtonCancel.loadFromFile("buttoncancelpressed.png");
							bSettingsCancel = true;
						}

						if (btnAllocatedMemory.isMouseOver(windowMain)) {
							bAllocatedMemory = true;
						}
						if (!btnAllocatedMemory.isMouseOver(windowMain)) {
							txbAllocatedRam.setSelected(false);
						}

						if (btnPathToGame.isMouseOver(windowMain)) {
							bPathToGame = true;
						}
						if (!btnPathToGame.isMouseOver(windowMain)) {
							txbPathToGame.setSelected(false);
						}
						break;
					case sf::Event::MouseButtonReleased:
						if (bSettingsApply) {
							txrButtonApply.loadFromFile("buttondef.png");
							bSettingsApply = false;
							bSettings2 = false;

							writeFileContentsTo(strSettingsContents, strProjectDirectory + strProjectFolder + "LauncherData\\settings.txt");

							if (nAllocatedRam > nMaximumRam) {
								nAllocatedRam = nMaximumRam;
							}

							std::remove((strProjectDirectory + strProjectFolder + "LauncherData\\settings.txt").c_str());
							
							strAllocatedRamField.clear();
							strAllocatedRamField = txbAllocatedRam.getText() + "0";

							nAllocatedRam = 0;

							for (int i = 1; i < strAllocatedRamField.size(); i++) {
								int multiplier = 1;
								for (int j = 0; j < (strAllocatedRamField.size() - i - 1); j++) {
									multiplier = multiplier * 10;
								}
								nAllocatedRam += (strAllocatedRamField.at(i - 1) - '0') * multiplier;
							}
							
							if (nAllocatedRam > nMaximumRam) {
								nAllocatedRam = nMaximumRam;
							}

							std::cout << "Settings:\nAllocated ram: " << nAllocatedRam << "\nPath to game: " + strPathToGameField;

							createFile("AllocatedRam=" + std::to_string(nAllocatedRam) + "\nPathToGameFolder=" + strProjectDirectory, strProjectDirectory + strProjectFolder + "LauncherData\\settings.txt");

							writeFileContentsTo(strSettingsContents, strProjectDirectory + strProjectFolder + "LauncherData\\settings.txt");
						}

						if (bSettingsCancel) {
							txrButtonCancel.loadFromFile("buttoncanceldef.png");
							bSettingsCancel = false;
							bSettings2 = false;
						}

						if (bAllocatedMemory) {
							bAllocatedMemory = false;
							txbAllocatedRam.setSelected(true);
						}

						if (bPathToGame) {
							bPathToGame = false;
							txbPathToGame.setSelected(true);
						}
						break;
					case sf::Event::TextEntered:
						txbAllocatedRam.onType(event);
						txbPathToGame.onType(event);
					}
				}
			}

			windowMain.clear();
			windowMain.draw(shapeBG);
			windowMain.draw(sprLogoBig);
			windowMain.draw(shapeLowerBG);
			btnPlay.render(windowMain);
			btnSettings.render(windowMain);
			btnDiscord.render(windowMain);
			txbNick.render(windowMain);
			txbPassword.render(windowMain);
			windowMain.draw(sprGear);
			windowMain.draw(sprPlay);
			windowMain.draw(sprDiscord);
			windowMain.draw(txtCredits);
			if (bSettings2) {
				windowMain.draw(shapeSettingsDarkOverlay);
				windowMain.draw(sprSettingsBG);
				btnSettingsApply.render(windowMain);
				btnSettingsCancel.render(windowMain);
				txbAllocatedRam.render(windowMain);
				txbPathToGame.render(windowMain);
				windowMain.draw(txtSettings);
				windowMain.draw(txtSettingsAllocatedRam);
				windowMain.draw(txtSettingsPathToGame);
			}
			windowMain.display();
		}
	}
}